<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Node.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">Node.java</span></div><h1>Node.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import static io.gitlab.littlesaints.protean.Constants.Context.EXCEPTION_HANDLER;
import static io.gitlab.littlesaints.protean.Constants.Context.FILTER;
import static io.gitlab.littlesaints.protean.Constants.Context.ROUTE_RESOLVER;
import static com.littlesaints.protean.functions.maths.Mathematician.isPowerOfTwo;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.util.function.BiFunction;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.Supplier;
import java.util.function.ToIntFunction;

import com.littlesaints.protean.functions.streams.If;
import io.gitlab.littlesaints.protean.configuration.*;
import io.gitlab.littlesaints.protean.event.State;
import com.littlesaints.protean.functions.trial.Strategy;
import io.gitlab.littlesaints.protean.resources.ResourceLocator;

import lombok.*;

/**
 * Defines a set processing options and configurations for a task to be executed on an event.
 * Nodes are the building blocks for a processing {@link Graph} that represents the complete execution workflow or pipeline.
 *
 * @see Graph
 */
<span class="nc" id="L52">@ToString</span>
@Getter
<span class="pc bpc" id="L54" title="13 of 14 branches missed.">@EqualsAndHashCode(of = {&quot;name&quot;}, doNotUseGetters = true)</span>
<span class="pc bpc" id="L55" title="4 of 8 branches missed.">@Builder</span>
public class Node&lt;E&gt; {

    @NonNull
<span class="fc" id="L59">    private final String name;</span>

    @NonNull
<span class="fc" id="L62">    private final Supplier&lt;Processor&lt;E&gt;&gt; processorSupplier;</span>

<span class="fc" id="L64">    private final boolean skippable;</span>

<span class="fc" id="L66">    private final int concurrency;</span>

<span class="nc" id="L68">    private final int buffer;</span>

<span class="fc" id="L70">    private final BiFunction&lt;E, Exception, State&gt; exceptionHandler;</span>

<span class="fc" id="L72">    private final Supplier&lt;Predicate&lt;E&gt;&gt; filter;</span>

<span class="nc" id="L74">    private final ToIntFunction&lt;E&gt; routeResolver;</span>

<span class="fc" id="L76">    private final Strategy retryStrategy;</span>

<span class="pc bpc" id="L78" title="3 of 6 branches missed.">    @Builder(builderClassName = &quot;NodeConfigurer&quot;, builderMethodName = &quot;configure&quot;, buildMethodName = &quot;get&quot;)</span>
<span class="pc bpc" id="L79" title="3 of 6 branches missed.">    private static &lt;E&gt; Node&lt;E&gt; from(@NonNull Configuration configuration, @NonNull ResourceLocator locator, @NonNull NodeOptions options) {</span>

        //TODO: add test for when no processor or invalid processor configured

<span class="fc" id="L83">        Collection&lt;Supplier&lt;Processor&lt;E&gt;&gt;&gt; processorSuppliers = new ArrayList&lt;&gt;();</span>
<span class="fc bfc" id="L84" title="All 2 branches covered.">        for (ProcessorOptions o : options.getProcessors()) {</span>
<span class="fc" id="L85">            processorSuppliers.add(Processor.supplier(configuration, locator, o));</span>
<span class="fc" id="L86">        }</span>
<span class="fc" id="L87">        final Node&lt;E&gt; node = Node.&lt;E&gt;builder()</span>
<span class="fc" id="L88">            .name(options.getName())</span>
<span class="fc" id="L89">            .processorSupplier(processorSuppliers.stream()</span>
<span class="fc" id="L90">                .reduce(Processor::compose)</span>
<span class="fc" id="L91">                .orElse(null))</span>
<span class="fc" id="L92">            .concurrency(options.getConcurrency())</span>
<span class="fc" id="L93">            .buffer(options.getBuffer())</span>
<span class="fc" id="L94">            .skippable(options.isSkippable())</span>
<span class="fc" id="L95">            .retryStrategy(options.getRetryStrategy())</span>
<span class="fc" id="L96">            .exceptionHandler(Optional.ofNullable(options.getExceptionHandler())</span>
<span class="fc" id="L97">                .map(o -&gt; locator.&lt;Function&lt;Config, BiFunction&lt;E, Exception, State&gt;&gt;&gt;lookupOrThrow(o.getSupplier(), EXCEPTION_HANDLER))</span>
<span class="fc" id="L98">                .map(f -&gt; f.apply(new Config(options.getExceptionHandler().getConfig())))</span>
<span class="fc" id="L99">                .orElse(null))</span>
//                .filter(locator.&lt;Supplier&lt;Predicate&lt;E&gt;&gt;&gt;optionalLookupOrThrow(options.getFilter(), FILTER).orElse(null))
<span class="fc" id="L101">            .filter(evaluateFilter(options.getFilter(), locator))</span>
<span class="fc" id="L102">            .routeResolver(locator.&lt;Function&lt;Integer, ToIntFunction&lt;E&gt;&gt;&gt;optionalLookupOrThrow(options.getRouteResolver(), ROUTE_RESOLVER)</span>
<span class="fc" id="L103">                .map(s -&gt; s.apply(options.getConcurrency()))</span>
<span class="fc" id="L104">                .orElse(null))</span>
<span class="fc" id="L105">            .build();</span>
<span class="fc" id="L106">        node.validate();</span>
<span class="fc" id="L107">        return node;</span>
    }

    //TODO: make a function
    private static &lt;E&gt; Supplier&lt;Predicate&lt;E&gt;&gt; evaluateFilter(GenericOptions options, ResourceLocator locator) {
<span class="pc" id="L112">        final Function&lt;GenericOptions, Optional&lt;Supplier&lt;Predicate&lt;E&gt;&gt;&gt;&gt; filterEvaluator = If.&lt;GenericOptions, Optional&lt;Supplier&lt;Predicate&lt;E&gt;&gt;&gt;&gt;test(f -&gt; f.getConfig().isEmpty())</span>
<span class="pc" id="L113">                .then(f -&gt; locator.optionalLookupOrThrow(f.getSupplier(), FILTER))</span>
<span class="pc" id="L114">                .orElse(f -&gt; locator.&lt;Function&lt;Config, Predicate&lt;E&gt;&gt;&gt;optionalLookupOrThrow(f.getSupplier(), FILTER)</span>
<span class="nc" id="L115">                        .map(fn -&gt; () -&gt; fn.apply(new Config(options.getConfig()))));</span>
<span class="fc" id="L116">        return Optional.ofNullable(options)</span>
<span class="fc" id="L117">                .flatMap(filterEvaluator)</span>
<span class="fc" id="L118">                .orElse(null);</span>
    }

    private void validate() {
<span class="fc" id="L122">		Objects.requireNonNull(name, &quot;name must be defined !!&quot;);</span>
<span class="fc" id="L123">		Objects.requireNonNull(processorSupplier, &quot;processorSupplier must be defined !!&quot;);</span>
<span class="pc bpc" id="L124" title="1 of 2 branches missed.">        if (concurrency &lt; 1) {</span>
<span class="nc" id="L125">            throw new RuntimeException(&quot;concurrency must be greater than 0&quot;);</span>
        }
<span class="fc bfc" id="L127" title="All 2 branches covered.">        if (routeResolver != null) {</span>
<span class="pc bpc" id="L128" title="1 of 2 branches missed.">            if (concurrency == 1) {</span>
<span class="nc" id="L129">                throw new RuntimeException(&quot;concurrency of 1 for ordered processing might cause missed processing for some events.&quot;);</span>
            }
<span class="pc bpc" id="L131" title="1 of 2 branches missed.">            if (!isPowerOfTwo.test(concurrency)) {</span>
<span class="nc" id="L132">                throw new RuntimeException(&quot;concurrency must be a power of 2 for ordered processing.&quot;);</span>
            }
        }
<span class="fc" id="L135">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>